#lang racket
(require rackunit)

(define (sum-list l)
  (cond [(empty? l) 0]
        [else
          ; l = (cons h r)
          ;             \----- (sum-list r) = s
          ; (+ h s)
          ; input = (list 30)
          (define s (sum-list (rest l))) ; (list) -> 0
          (define h (first l)) ; 30
          (+ h s) ; input = (list 30) -> 30
          ]
))

(sum-list (list 10 20 30))
; (10 20 30)
; (cons 10 (20 30))
;;          (sum-list (20 30)) = 50
;;;                       (list 30)










(check-equal? 10 (sum-list (list 1 2 3 4)))
(check-equal? 0 (sum-list (list)))





(define (count-down n)
  (cond [(= n 0) (list)]
    [ else
      (define l (count-down (- n 1))) ; (count-down 2) -> (list 2 1)
      ; n = 3
      (cons n l)]
  ))












(check-equal? (list) (count-down 0))
(check-equal? (list 3 2 1) (count-down 3))






(define (zip l1 l2)
  (cond [(or (empty? l1) (empty? l2)) (list) ]
        [else
          ; l1 = ( 3  2  1)
          ; l2 = (30 20 10)
          (define l (zip (rest l1) (rest l2))) ; (zip (2 1) (20 10)) -> ( (2 . 20) (1 . 10) )
          (define x (first l1)) ; 3
          (define y (first l2)) ; 30
          ; ( (3 . 30) (2 . 20) (1 . 10) )
          ;    ------- ~~~~~\/~~~~~~~~~~~
          ;                 l
          (cons (cons x y) l)]))


(check-equal? (list (cons 3 30) (cons 2 20) (cons 1 10))
              (zip (list 3 2 1) (list 30 20 10)))
(check-equal? (list (cons 3 30) (cons 2 20) (cons 1 10))
              (zip (list 3 2 1) (list 30 20 10 5 4 3 2 1)))
(check-equal? (list (cons 3 30) (cons 2 20) (cons 1 10))
              (zip (list 3 2 1 90 180 270) (list 30 20 10)))

(define (countup-from1 x)
  (define (count from)
    (cond
      [(equal? from x) (list x)]
      [else (cons from (count (+ 1 from)))]))
  (count 1))



(check-equal? (list 1) (countup-from1 1))
(check-equal? (list 1 2) (countup-from1 2))
(check-equal? (list 1 2 3 4 5) (countup-from1 5))

(define z 10)

(define (f x)
  (define x 3) ; Shadows parameter
  ; z = 10
  (define z 20)  ; Shadows global
  ; z = 20
  (+ x z))
(f 1) ; Outputs 23
; z = 10

(define (max xs)
  (cond
    [(empty? xs) (error "max: expecting a non-empty list!")]
    [(equal? (length xs) 1) (first xs)]             ; The list only has one element (the max)
    [(> (first xs) (max (rest xs))) (first xs)] ; The max of the rest is smaller than 1st
    [else (max (rest xs))]))                    ; Otherwise, use the max of the rest
; A simple unit-test
(require rackunit)
(check-equal? 10 (max (list 1 2 10 4 0)))
















